<template>
  <div class="app">
    <div class="app-snackbar position-fixed fixed-bottom m-3 m-md-5 py-5 d-flex justify-content-center w-100">
      <app-snackbar />
    </div>
    <vue-progress-bar />
    <div class="site-wrapper">
      <deu-header project="hub" active-menu-item="data" :enable-authentication="isAuthEnabled"
        :authenticated="isAuthenticated" use-breadcrumbs use-breadcrumbs-route-meta @login="doLogin" @logout="doLogout"
        :showSparql="showSparql" />
      <router-view class="content" :key="$route?.fullPath" />
      <deu-footer :enable-authentication="isAuthEnabled" :authenticated="isAuthenticated"
        :use-login="$env.authentication.login.useLogin" :login="$env.authentication.login.loginURL"
        :login-title="$env.authentication.login.loginTitle" :logout="$env.authentication.login.logoutURL"
        :logout-title="$env.authentication.login.logoutTitle" @click-follow-link="handleFollowClick" />
    </div>
    <dpiMenu v-if="isAuthenticated">
      <template #right="{ getUserData }">
        <small class="text-white">{{ $t('message.dataupload.menu.loggedInAs') }} {{ getUserData.userName }}</small><br>
        <button type="button" class="btn btn-outline-light" @click="doLogout">{{ $t('message.dataupload.menu.logout') }}
        </button>
      </template>
    </dpiMenu>
    <cookie-consent :piwik-instance="$piwik" />
    <LoginRedirect />
  </div>
</template>

<script>
/* eslint-disable no-underscore-dangle */
import { defineComponent, computed, getCurrentInstance, watch, ref } from 'vue';
import { usePvAuth, LoginRedirect, useRptQuery } from '@piveau/piveau-hub-ui-plugin-auth';
import CookieConsent from './cookie-consent/CookieConsent';
import {
  DpiMenu,
  useRuntimeEnv,
} from '@piveau/piveau-hub-ui-modules';
import { useStore } from 'vuex';

export default defineComponent({
  name: 'app',
  components: {
    CookieConsent,
    DpiMenu,
    LoginRedirect,
  },
  metaInfo() {
    return {
      titleTemplate(chunk) {
        return chunk ? `${chunk} - ${this.$env.metadata.title}` : this.$env.metadata.title;
      },
      meta: [
        { name: 'description', vmid: 'description', content: this.$env.metadata.description },
        { name: 'keywords', vmid: 'keywords', content: this.$env.metadata.keywords },
      ],
      htmlAttrs: {
        lang: this.$route.query.locale,
      }
    };
  },
  data() {
    return {
      tracker: null,
      matomoURL: this.$env.tracker.trackerUrl,
      piwikId: this.$env.tracker.siteId,
      lastRoute: null,
      keycloak: this.$keycloak,
      showSparql: this.$env.routing.navigation.showSparql,
    };
  },
  watch: {
    '$route'(to) {
      if (to.path.endsWith('/embed-snippet') || to.path.endsWith('/embed')) {
        document.body.classList.add('embed-view');
      } else {
        document.body.classList.remove('embed-view');
      }
    }
  },
  computed: {
    authEnabled() {
      return this.$env?.authentication?.useService && this.$env.authentication?.login?.useLogin;
    },
    // isAuthenticated() {
    //   return this.authEnabled && this.keycloak?.authenticated;
    // }
  },
  methods: {
    euLogin() {
      window.location.href = "https://data.europa.eu/euodp/data/user/login";
    },
    euLogout() { },
    handleFollowClick(url) {
      this.$piwik.trackOutlink(url);
    },
  },
  setup() {
    const pvAuth = usePvAuth();
    const vm = getCurrentInstance();
    const env = useRuntimeEnv();

    if (!pvAuth) return;
    if (!vm) return;

    const store = useStore();

    function updateUserData(payload) {
      store.dispatch('auth/updateUserData', payload);
    }

    const { data: rpt, isSuccess: isRptSuccess } = useRptQuery();

    const successOnce = ref(false);
    watch(isRptSuccess, (success) => {
      if (!success) return;
      if (successOnce.value) return;
      successOnce.value = true;
      store.dispatch('snackbar/showSnackbar', {
        message: 'Successfully logged in',
        variant: 'success',
      })

      if (!rpt.value?.access_token) {
        store.dispatch('snackbar/showSnackbar', {
          message: 'You do not have permissions to access any catalogue, please contact the administrators.',
          variant: 'error',
          timeout: 12000,
        })
      }

    }, { immediate: true })

    watch(rpt, (newRpt) => {
      if (newRpt.access_token) {
        updateUserData({
          authToken: '__authtoken__',
          rtpToken: newRpt.access_token,
          hubUrl: env.api.hubUrl,
        })
      }
    })

    async function doLogin() {
      vm.appContext.config.globalProperties.$Progress.start();

      try {
        await pvAuth.login()
      } catch (error) {
        store.dispatch('snackbar/showSnackbar', {
          message: `An error occurred while attempting to move to the login page: ${error.message}`,
          variant: 'error',
        })
        console.error('Error while logging in', error)
      } finally {
        vm.appContext.config.globalProperties.$Progress.finish();
      }
    }

    function doLogout() {
      pvAuth.logout();
    }

    const isAuthEnabled = computed(() => pvAuth.options.enabled)
    const isAuthenticated = computed(() => pvAuth.authData.value.isAuthenticated)

    return {
      doLogin, doLogout, isAuthenticated, isAuthEnabled, isRptSuccess,
    };
  }
});
</script>

<style lang="scss">
// Normalizes default css rules. See: https://github.com/necolas/normalize.css
@import './styles/utils/normalize.css';

@font-face {
  font-family: "Ubuntu";
  src: local("Ubuntu"), url(../static/fonts/Ubuntu/Ubuntu-Regular.ttf) format("truetype");
}

// Embed view customization
.embed-view .deu-header-footer,
.embed-view .deu-header {
  display: none !important;
}

* {
  box-sizing: border-box;
}

.site-wrapper header {
  display: initial;
}

.container-fluid {
  max-width: 1340px !important;
}

.ecl-select__icon.ec-ds-scope-select {
  background-color: #0e47cb !important;
}

.ecl-select__icon:hover {
  background-color: #0e47cb !important;
}

.value-display:hover,
#select-default:hover,
.ecl-select__container:hover {
  .ecl-select__icon {
    background-color: #3e6cd5 !important;
  }
}

.value-display:focus,
#select-default:focus,
.ecl-select__container:focus {
  border: 1px solid #0e47cb !important;

  .ecl-select__icon {
    background-color: #0e47cb !important;
  }
}

.router-link-inactive {
  color: #7f7f7f !important;
}
</style>

<style lang="scss" scoped>
.app {
  background-color: #fff;
}

.site-wrapper {
  border: 0;
  max-width: none;
  box-shadow: none;
  display: initial;

  .content {
    padding: 30px 30px 0 30px;
    margin-top: 15px;
    margin-bottom: 15px;
    background-color: white;
  }
}

.app-snackbar {
  z-index: 9999;
  pointer-events: none;
}
</style>
